%{
#include "symtable.h"
double shrink(double i) { return i*0.8; };
double disp(double h1, double h2) { return h1+0.5*h2; };
%}

%token SUB
%token TEXT

%%
S: L B {
        $$.ht=$2.ht;
	cout << "S(ht=" << $$.ht << ",ps=" << $1.ps <<
	  "): L B(\"" << symtable[$2.tptr] << "\")\n";}
	  
B: B M SS {
     $$.ht=max($1.ht,$3.ht);
     $$.tptr=addtotable(symtable[$1.tptr]+" "+symtable[$3.tptr]);
     cout << "B(ht=" << $$.ht << ",ps=" << $0.ps <<
     "): B(\"" << symtable[$1.tptr] << "\") M SS(\""
     << symtable[$3.tptr] << "\")\n";}
     
B: SS {cout << "B: SS(\"" << symtable[$1.tptr] << "\")\n";}

SS: W SUB N SS {
     $$.ht=disp($1.ht,$4.ht);
     $$.tptr=addtotable(symtable[$1.tptr]+" SUB "+symtable[$4.tptr]);
     cout << "B(ht=" << $$.ht << ",ps=" << $0.ps <<
     "): W(\"" << symtable[$1.tptr] << "\") SUB N B(\"" <<
     symtable[$4.tptr]<< "\")\n";}
     
SS: W {cout << "SS: W(\"" << symtable[$1.tptr] << "\")\n";}

W: TEXT {
          $$.ht=0.2*$0.ps;
          cout << "W: TEXT (ht=" << $$.ht <<
	  ")(\"" << symtable[$1.tptr] << "\")\n";}
	  
L: { $$.ps=10.0; cout << "L: E\n";}

M: { $$.ps=$-1.ps; cout << "M: E ps=" << $$.ps << endl;}

N: { $$.ps=shrink($-2.ps); cout << "N: E ps=" << $$.ps << endl;}
%%
void yyerror(char const *s)
{
  printf("%s\n",s);
};

int main()
{
  yyparse();
};

symtable_t symtable;

int addtotable(const string& s)
{
symtable.push_back(s);
return symtable.size()-1;
};
